<?php

namespace LQDN\Finder;

use Doctrine\DBAL\Connection;

class AddressFinder
{
    private $connection;

    public function __construct(Connection $connection)
    {
        $this->connection = $connection;
    }

    /**
     * Return all adresses of a given user.
     *
     * @param mixed $userId
     *
     * @return array
     */
    public function findByUserId($userId)
    {
        $userId = (int) $userId;
        $addresses = [];
        $stmt = $this->connection->executeQuery('SELECT * FROM adresses WHERE user_id = :user_id', ['user_id' => $userId]);
        while ($address = $stmt->fetch()) {
            $addresses[$address['id']] = $address;
        }

        return $addresses;
    }
}
